<?php
ob_start();
error_reporting(E_ERROR | E_PARSE);
require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/' . "wp-config.php");

$SKRAPE = get_option('SKRAPE');
if($_GET['debug']){
 echo '<b>Starting Skrape Debug Mode</b><br>';
}
 
$urlvars['numericmonth'] = date('m');
$urlvars['stringmonth'] = date('F');
$urlvars['numericday'] = date('d');
$urlvars['numericyear'] = date('Y');
$urlvars['stringmonthshort'] = strtoupper(date('M'));

// Build dynamic link
$skrape_url = $SKRAPE['skrape_url'];
foreach($urlvars as $key => $val){
	$pattern = "%$key%";
	$skrape_url = ereg_replace($pattern,$val,$skrape_url);
}
$SKRAPE['skrape_url'] = $skrape_url;

// Build date stamps
$SKRAPE['post_date'] = date("Y-m-d H:i:s");
$SKRAPE['post_date_gmt'] = date("Y-m-d H:i:s");
$SKRAPE['timezonediff'] = gmdate("Y-m-d H:i:s");

$SKRAPE['SERVER_HAS_CURL'] = function_exists('curl_exec');// Does the server have CURL installed in its php
$SKRAPE['wp_db_connected'] = true;// Can we connect to the wordpress db (change this to a real function)

//-------------------> Functions ----------------------------------->

function skrape_run_search_patterns($buffer){
 global $SKRAPE;
 /* Clean up patterns forward salshes in html will break the pattern and need to be escaped */
 preg_match_all($SKRAPE['regex_content'], $buffer, $matches, PREG_OFFSET_CAPTURE, 1);
 // $matches array can be mis-structured if the container_pattern uses multiple groupings! 
 return $matches[0][0][0];
}
// end function run_search_patterns


function skrape_login_with_curl(){
 
 global $SKRAPE;
 if($_GET['debug']) echo 'Logging in...<br>';
 $ch = curl_init();
 //curl_setopt ($ch, CURLOPT_PROXY, $proxy);
 curl_setopt($ch, CURLOPT_USERAGENT,  $SKRAPE['user_agent']);
 curl_setopt($ch, CURLOPT_COOKIEJAR, "/tmp/cookie3.txt");
 curl_setopt($ch, CURLOPT_HEADER, 1);
 curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
 curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
 curl_setopt($ch, CURLOPT_TIMEOUT, 120);
 
 foreach($SKRAPE['login_elements'] as $key => $val){
    $poststring .= $key . '=' . $val . '&';
 }
 //$poststring = urlencode($poststring);
 
 if($SKRAPE['form_method'] == 'POST'){
    curl_setopt($ch, CURLOPT_POST, 1 );
	curl_setopt($ch, CURLOPT_URL, $SKRAPE['login_url']);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $poststring);
 } else {
    curl_setopt($ch, CURLOPT_URL, $SKRAPE['login_url'] . '?' . $poststring);
 }
 
 $result = curl_exec ($ch);
 curl_close($ch);
 unset($result);
 // Figure out a way to determine if the login was ok or not
 return true;
}
// end skrape_login_with_curl

function skrape_urls_with_curl(){
   global $SKRAPE;
   if($_GET['debug']) echo 'Running CURL<br>';
   $ch = curl_init();
   curl_setopt ($ch, CURLOPT_URL, $SKRAPE['skrape_url']);
   curl_setopt ($ch, CURLOPT_USERAGENT, $SKRAPE['user_agent']);
   curl_setopt ($ch, CURLOPT_COOKIEFILE, "/tmp/cookie3.txt");
   curl_setopt ($ch, CURLOPT_HEADER, 1);
   curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
   curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
   curl_setopt ($ch, CURLOPT_TIMEOUT, 120);

   $result = curl_exec ($ch);
   curl_close($ch);
   $result = skrape_run_search_patterns($result);
   return $result;
}
// end function skrape_urls_with_curl


//-------------------> End Functions ------------------------------->


//-------------------> Main  --------------------------------------->

if($SKRAPE['SERVER_HAS_CURL'] && $SKRAPE['wp_db_connected']){
echo "has curl && db_connected<br>";

	if($SKRAPE['login_before_skrape']){
		// Curl login to the site
		echo "login before skrape<br>";
		$skrape_login = skrape_login_with_curl();
	}
	
	if($skrape_login || $SKRAPE['login_before_skrape'] == 0){
		// Skrape the page
		echo "login ok<br>";
		$skrape_content = skrape_urls_with_curl();
	}

	if($SKRAPE['regex_post_title']){
		preg_match_all($SKRAPE['regex_post_title'],$skrape_content,$matches);
		$post_title = $matches[1][0];
	} elseif($SKRAPE['post_title']){
		$post_title = $SKRAPE['post_title'];
	} else {
		$post_title = 'Skraped Content';
	}
	
	if(!$post_title || $post_title == '') $post_title = 'Skraped Content';

	//--> If we have content to post
	if($skrape_content){
		echo "got content, time to insert into db <br>";
		$details = array(
        'post_author'		=> '1',
        'post_date'			=> $SKRAPE['post_date'],
        'post_date_gmt'		=> $SKRAPE['post_date_gmt'],
        'post_content'		=> preg_replace("/'/","\\'",$skrape_content),
        'post_title'		=> $post_title,
        'post_modified'		=> $SKRAPE['post_date'],
        'post_modified_gmt'	=> $SKRAPE['post_date_gmt'],
        'ping_status' => get_settings('default_ping_status'),
        'post_category' => $SKRAPE['wp_category'],
        'comment_status' => $comment_status,
        'post_name' => sanitize_title($post_title),
        'post_status' => 'publish');

     //-->Let wordpress do the post insertion
     $post_ID = wp_insert_post($details);
     do_action('publish_post', $post_ID);
	 do_action('publish_phone', $post_ID);

	} //if skrape_content
}
if($_GET['debug']){
?>
<pre>
SKRAPE runtime varibles
<? var_dump($SKRAPE); ?>

<br><br>
Post string for login: 
<? var_dump($poststring);?>

Curl Contents (if this is NULL make sure your <a href='curltest.php'>CURL is working</a>)
<? var_dump($skrape_content);?>

Details Array (what is going into WordPress, if this is NULL, nothing is going in)
<? var_dump($details); ?>
</pre>
<? } ?>
