<?php
ob_start();
error_reporting(E_ERROR | E_PARSE);
require_once('admin.php');
echo $version;
global $wpdb,$wp_roles;

        /* if (!TestWPVersion()) {
            print("<h1>Warning!</h1>
                    <p>Skrape has only been tested on Word Press version 2.0</p>");
        exit();
        } */
$title = __('Skrape Options');
$parent_file = 'options-general.php';
//$config = GetConfig();
$messages[1] = "Configuration successfully updated!";
$messages[2] = "Error - unable to save configuration";
$messages[3] = "Error - Your server does not have the CURL PHP extension. This plugin will not work without it!";

if(!function_exists('curl_exec')) $_GET['message'] = 3;
$config = get_option('SKRAPE');
if(!function_exists('BuildBooleanSelect')){
 function BuildBooleanSelect($label,$id,$current_value,$recommendation = NULL) {
   return("<tr>
	<th scope=\"row\">". __($label).":</th>
	<td><select name=\"$id\" id=\"$id\">
    <option value=\"1\">".__("Yes")."</option>
    <option value=\"0\" ". (!$current_value ? "SELECTED" : NULL) . ">".__("No").'</option>
	</select>
    <br /><code>'.__($recommendation).'</code><br/>
    </td>
	</tr>');
 }
}
?>
 
<?php if (isset($_GET['message'])) : ?>
<div class="updated"><p><?php _e($messages[$_GET['message']]); ?></p></div>
<?php endif; ?>
<script type=text/javascript>
function addloginelement(){
	oDiv = document.getElementById("loginelements")
	oDiv.innerHTML = oDiv.innerHTML + 'Element:<input name="login_elements_newkey[]" type="text" size=20> Value:<input name="login_elements_newval[]" type="text" size=20><br>'
}
</script>
<div class="wrap"> 
<h2><?php _e('Skrape Options') ?></h2> 

<form name="skrape-options" method="post" action="<?php echo  get_settings('siteurl') . "/wp-content/plugins/skrape/config_handler.php"?>"> 
	<input type="hidden" name="action" value="config" />
	<table width="100%" cellspacing="2" cellpadding="5" class="editform"> 
	    <tr><td colspan=2> 
        <fieldset class="options"> 
        <legend><?php _e('Main Settings');?></legend>
        <table width="100%" cellspacing="2" cellpadding="5" class="editform">    
		<tr valign="top">
                        <td><?php echo BuildBooleanSelect("Login before Skraping","login_before_skrape",$config["login_before_skrape"]);?>
                        </td>
                </tr>
		<tr valign="top">
		<th width="33%" scope="row"><?php _e('Login Form method:') ?></th>
                        <td><select name="form_method" id="form_method">
        <option value="POST">POST</option>
        <option value="GET" <?php if($config["form_method"] == "GET") { echo "SELECTED";} ?>>GET</option>
        </select>
                        </td>
                </tr>
			<th scope="row"><?php _e('Login URL:') ?></th>
			<td><input name="login_url" type="text" id="login_url" value="<?php echo $config["login_url"];?>" size="80" />
			</td>
		</tr>
		<tr valign="top">
			<th width="33%" scope="row"><?php _e('Login Form Elements:') ?></th>
<table align=center padding=30>
<?
if(is_array($config["login_elements"])){
   foreach($config["login_elements"] as $key => $val){
?><tr><td><?
      echo $key . ':</td><td> <input name="login_elements[' . $key . ']" type="text" value="' . $val . '" size=30>';
?></td></tr><?
   }
}
?></table>
</td>
                </tr>
                <tr valign="top">
                        <th width="33%" scope="row"><?php _e('New Login Form Elements:') ?></th>
                        <td><div id=loginelements>Element:<input name="login_elements_newkey[]" type="text" size=20> Value:<input name="login_elements_newval[]" type="text" size=20><br></div>
<div align="right"><input type="button" value="Add Login Value" name="add_login_elements" id="add_login_elements" onclick="addloginelement();"></div>
</td>
		</tr>
                <tr valign="top">
                        <th scope="row"><?php _e('URL to Skrape:') ?></th>
                        <td>
                                <input name="skrape_url" type="text" id="skrape_url" value="<?php echo $config["skrape_url"]; ?>" size="80" />
                        </td>
                </tr>
		<tr valign="top">
			<th scope="row"><?php _e('User Agent:') ?></th>
			<td>
				<input name="user_agent" type="text" id="user_agent" value="<?php echo $config["user_agent"]; ?>" size="80" />
			</td>
		</tr>
                <tr valign="top">
                        <th scope="row"><?php _e('Post title REGEX:') ?></th>
                        <td>
                                <input name="regex_post_title" type="text" id="regex_post_title" value='<?php echo htmlentities($config["regex_post_title"]); ?>' size="80" />
								<br> (Watch out for any extra \'s added in here by magic_qoutes)
                        </td>
                </tr>
                <tr valign="top">
                        <th scope="row"><?php _e('Content REGEX:') ?></th>
                        <td>
                                <input name="regex_content" type="text" id="regex_content" value='<?php echo htmlentities($config["regex_content"]); ?>' size="80" />
								<br> (Watch out for any extra \'s added in here by magic_qoutes)
                        </td>
                </tr>
            <tr valign="top">
                <th scope="row"><?php _e('Default post category:') ?></th>
                <td><select name="wp_category" id="wp_category">
                        <?php
                        $categories = $wpdb->get_results("SELECT * FROM $wpdb->categories ORDER BY cat_name");
                        foreach ($categories as $category) {
                            $selected = ($category->cat_ID == $config["wp_category"][0] ? "SELECTED": NULL);
                            echo "\n\t<option value='$category->cat_ID' $selected>$category->cat_name</option>";
                        }
                        ?>
                </select></td>
            </tr>
	</table>
</fieldset>
    </td>
    </tr>
	</table> 
	<p class="submit">
		<input type="submit" name="Submit" value="<?php _e('Update Options') ?> &raquo;" />
	</p>
</form> 
</div>
